#ifndef __APPLICATION__
#define __APPLICATION__

class TAbstractDocument;

//
// For class definition of TAbstractScriptableObject
//
#include "AbstractScriptableObject.h"

#include "Int64.h"

#define clApplication 10

//================================================================================
// Class TApplication
//================================================================================
class TApplication : public TAbstractScriptableObject
{
private:
	Boolean								fCloseRequestsPending;
	long								fResolutionMode;
	
public:
	DeclareClassData(TApplication, TAbstractScriptableObject);

	TApplication() : fCloseRequestsPending(false), fResolutionMode(3) {}
	
	virtual DescType					ObjectClass(TTransaction* t, Boolean recordedClass = false);
	virtual Boolean						DerivedFromOSLClass(TTransaction* t, DescType objectClass);

	virtual TAbstractObjectIterator*	ElementIterator(TTransaction* t);
//	virtual long						CountElements(DescType classToCount = typeWildCard);
//	virtual TAbstractScriptableObject*	AccessByIndex(DescType desiredClass, long index);
	virtual TAbstractScriptableObject*	AccessByUniqueID(TTransaction* t, DescType desiredClass, TDescriptor uniqueID);

	virtual TDescriptor					GetProperty(TTransaction* t, DescType propertyName, DescType desiredType, unsigned long additionalInfo = 0);
	virtual void						SetProperty(TTransaction* transaction, DescType propertyName, TDescriptor& data, unsigned long additionalInfo = 0);

	virtual TDescriptor					AECommand(TTransaction* transaction, TAEvent ae, TAEvent reply, long aeCommandID, TAbstractScriptableObject* auxObjects = nil, long auxInfo = 0);
	virtual TAbstractScriptableObject*	CreateNewElement(TTransaction* transaction, TAEvent ae, TAEvent reply, DescType newObjectClass, TDescriptor initialData, TDescriptor initialProperties, Boolean& usedInitialData, Boolean& usedInitialProperties);

	TAbstractDocument*					FindDocument(Int64, Boolean searchForAndOpen = false);
	long								DocumentIndex(Int64 documentID);

	void								Idle();
	void								MarkForClose(TAbstractDocument* doc);
	void								ProcessCloseRequest();
	void								TearDownApplication();
	
	void								SetResolutionMode(long newValue);	
};

extern TApplication* gApplication;

#endif
