
#ifndef __DBELEMENTTOKENITERATOR__
#define __DBELEMENTTOKENITERATOR__

#include "AbstractScriptableObject.h"
#include "DBRecord.h"
#include "ReferenceTemplates.h"
#include "AbstractIterator.h"

class TDBElement;

//========================================================================================
// Class TDBElementTokenIterator 
//========================================================================================
class TDBElementTokenIterator : public TAbstractObjectIterator
{
	AConst<TDBRecord>					fIteratorOwner;
	TAbstractRecordIterator				fIterator;
	
	virtual ~TDBElementTokenIterator();
	
public:
	TDBElementTokenIterator(TTransaction* t, AConst<TDBRecord> iteratorOwner) :
		fIteratorOwner(iteratorOwner),
		fIterator(t, iteratorOwner) {}

	
	virtual void						Reset(TTransaction* t, Boolean iterationDirection = kForwardIteration);
	virtual Boolean						More(TTransaction* t) const;
	virtual void						Next(TTransaction* t);
	virtual TAbstractScriptableObject*	Current(TTransaction* t);
	
	virtual Boolean						CurrentDerivedFromOSLClass(TTransaction* t, DescType objectClass);
	virtual TAbstractScriptableObject*	GetNamedElement(TTransaction* t, DescType desiredClass, TDescriptor nameDesc);
	virtual void						AccessBySearchSpec(TTransaction* t, TAbstractCollector* collector, DescType desiredClass, TAbstractSearchSpec* searchSpec);
//	virtual Boolean						Contains(TTransaction* t, TAbstractScriptableObject* objectToTestForMembership);
};

#endif
