
#ifndef __HFSBACKINGSTORE__
#define __HFSBACKINGSTORE__

//
// For class definition of TAbstractBackingStore
//
#include "DatabaseDocument.h"


//
// What is a good cookie to indicate 'file closed'?
//
enum
{
	kFileNotOpen = -1
};

#define kDBCreator 'db++'
#define kDBType 'db  '

//================================================================================
// Class THFSBackingStore
//================================================================================
class THFSBackingStore : public TAbstractBackingStore
{
private:
	FSSpec								fFileSpec;
	short								fRefNum;
	long								fFileEOF;
	
public:
	THFSBackingStore();
	THFSBackingStore(FSSpec& fileSpec);
	virtual ~THFSBackingStore();

	virtual Boolean						CanSaveDocument();
	
	virtual void						Read(void* bufferStart, long startByteInFile, long numberOfBytes);
	virtual void						Write(void* bufferStart, long startByteInFile, long numberOfBytes);

	virtual void						DocumentName(TUpdataDataReference& name);

protected:
	void								OpenFile();
	void								CloseFile();
};

#endif
