
#ifndef __SCRIPTABLEDBDOCUMENT__
#define __SCRIPTABLEDBDOCUMENT__

class TDatabaseDocument;
class TAbstractBackingStore;

//
// For class definition of TAbstractDocument
//
#include "AbstractDocument.h"

//
// For class definition of TDatabaseDocument
//
#include "DatabaseDocument.h"

#include "Debug.h"

#define clScriptableDBDocument 100

//================================================================================
// Class TScriptableDBDocument
//
// Actually, I don't think I need to use MI here.  Containing a
// TDatabaseDocument should be suficient.
//================================================================================
class TScriptableDBDocument : public TAbstractDocument, public TDatabaseDocument
{
private:
	
public:
	DeclareClassData(TScriptableDBDocument, TAbstractDocument);

	TScriptableDBDocument() : TDatabaseDocument() {}
	TScriptableDBDocument(TAbstractBackingStore* backingStore) : TDatabaseDocument(backingStore) {}
	
	virtual ~TScriptableDBDocument();
	
	static TScriptableDBDocument*		NewDatabase();
	static TScriptableDBDocument*		OpenDatabase(FSSpec& fileSpec);
		
	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	// Overrides of class TAbstractDocument
	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	virtual Int64						DocumentIdentifier() const;
		
	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	// Overrides of class TAbstractScriptableObject
	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	
	virtual TDescriptor					GetProperty(TTransaction* t, DescType propertyName, DescType desiredType, unsigned long additionalInfo);
	virtual void						SetProperty(TTransaction* transaction, DescType propertyName, TDescriptor& data, unsigned long additionalInfo);

	virtual void						MakeKeyDataForSelf(TTransaction* t, DescType& keyForm, TDescriptor& keyData);

	virtual TDescriptor					AECommand(TTransaction* transaction, TAEvent ae, TAEvent reply, long aeCommandID, TAbstractScriptableObject* auxObjects = nil, long auxInfo = 0);
	virtual TAbstractScriptableObject*	CreateNewElement(TTransaction* transaction, TAEvent ae, TAEvent reply, DescType newObjectClass, TDescriptor initialData, TDescriptor initialProperties, Boolean& usedInitialData, Boolean& usedInitialProperties);

	virtual TAbstractScriptableObject*	RepresentativeScriptingObject(TTransaction* t);
	virtual Boolean						SendCommandToRepresentative(TTransaction* t, long aeCommandID);

	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	// Methods of TScriptableDBDocument
	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	void								Save()						{ this->FlushChangesToDisk(); }
	void								SaveAs(FSSpec& fileSpec);
};

#endif
