/*
	File:		Behavior.c

	Contains:	Behavior magic

	Written by:	Greg Anderson, Chris Bingham

	Copyright:	 1992, 1994-1995 by Apple Computer, Inc., all rights reserved.

		 <3>	 6/15/95	ga		
*/

#ifdef MWTRACEBACKTABLES
#pragma traceback on
#endif

#include "Behavior.h"


//========================================================================================
// CLASS TBehavior
//========================================================================================

#pragma segment ObjectResident
ImplementSmallClassData(TBehavior, clBehavior);

#pragma segment Behavior

//----------------------------------------------------------------------------------------
// TBehavior::~TBehavior
//----------------------------------------------------------------------------------------
TBehavior::~TBehavior()
	{
	if(fNextBehavior)
		delete fNextBehavior;
	}

//----------------------------------------------------------------------------------------
// TBehavior::SetNextBehavior: 
//----------------------------------------------------------------------------------------
void TBehavior::SetNextBehavior(TBehavior* behavior, TObject* owner)
	{
	fBehaviorOwner = owner;
	fNextBehavior = behavior;
	} 


//----------------------------------------------------------------------------------------
// TBehavior::NextBehaviorOfClass: 
//----------------------------------------------------------------------------------------
TBehavior* TBehavior::NextBehaviorOfClass(long classID) const
	{
	TBehavior* behavior = this->NextBehavior();
	
	while((behavior != nil) && (behavior->DerivedFrom(classID) == false))
		behavior = behavior->NextBehavior();
	
	return behavior;
	}




