
#ifndef __THREADCONTEXT__
#define __THREADCONTEXT__

class TException;

#include <Threads.h>

pascal OSErr ThreadCreateNotifyHandler(ThreadID createdThread, long threadCreateRefcon);

class TThreadContext
{
private:
	static long		fCreatedThreads;
	static long		fSleepingThreads;
	
public:
					TThreadContext(long threadCreateRefcon) :
#if __MWERKS__
					fLocalDestructorChain(nil),
#endif
					fThreadCreateRefcon(threadCreateRefcon),
					fExceptionStack(nil),
					fSleeping(false)
					{ ++fCreatedThreads; };
	~TThreadContext() { --fCreatedThreads; if(fSleeping) --fSleepingThreads; }
	
	void			SwapIn(ThreadID);
	void			SwapOut(ThreadID);
	void			DisposeContext(ThreadID);

	long			ThreadCreateRefcon() const { return fThreadCreateRefcon; }
	
	static long		TotalThreads() { return fCreatedThreads; }
	static long		SleepingThreads() { return fSleepingThreads; }
	static long		ActiveThreads() { return TotalThreads() - SleepingThreads(); }
	
private:

#if __MWERKS__
	void*			fLocalDestructorChain;
#endif
	const long		fThreadCreateRefcon;
	TException*		fExceptionStack;
	unsigned long	fSleeping : 1;
};

#endif
