
#ifndef __ABSTRACTDESIGNATOR__
#define __ABSTRACTDESIGNATOR__

//
// TAbstractScriptableObject is the base class
// for TAbstractDesignator
//
#include "AbstractScriptableObject.h"


//========================================================================================
//	CLASS TAbstractDesignator
//========================================================================================

class TAbstractDesignator : public TAbstractScriptableObject
	{
private:
	TAbstractScriptableObject*			fObjectOfDesignation;

protected:
	long								fReferenceCount;		// Should be private, but protected access is provided for debugging purposes
	
public:
	DeclareSmallClassData(TAbstractDesignator, TAbstractScriptableObject);

										TAbstractDesignator() : fObjectOfDesignation(nil), fReferenceCount(0) {};
	virtual								~TAbstractDesignator();
	void								IAbstractDesignator(TAbstractScriptableObject* objectOfDesignation);
	virtual Boolean						IsDesignator();
	virtual void						DisposeDesignator();
	virtual TAbstractScriptableObject*	CloneDesignator();

	virtual void						CloneOwnedObjects();

	TAbstractScriptableObject*			ObjectOfDesignation() { return fObjectOfDesignation; };
	virtual TAbstractScriptableObject*	ParentObject(TTransaction*);

	virtual Boolean						DelegateProperty(DescType propertyIdentifier);
	virtual TAbstractScriptableObject*	AccessByProperty(TTransaction* t, DescType propertyIdentifier);
	
	};

#endif
