/*
	File:		AbstractReference.h

	Contains:	xxx put contents here xxx

	Written by:	Andy Nicholas, Greg Anderson, Tom Conrad, Chris Bingham, Georgiann Puckett, John Thompson-Rohrlich

	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.

		 <6>	  4/7/95	jtr		
*/


#ifndef AbstractReference_h
#define AbstractReference_h

//
// AbstractDesignator.h is needed because
// TAbstractDesignator is the base class of
// TAbstractReference
//
#include "AbstractDesignator.h"

//
// List.h is needed for the DECLARELIST and
// DECLARELOOP macros
//
#include "List.h"

class TAbstractReference;

typedef TAbstractScriptableObject* (*CreateObjectFromReferenceProcPtr)(TAbstractReference*);

class TAbstractReference : public TAbstractDesignator
	{

	//
	// --- Methods -------------------------------------------------------------------------------------
	//
public:

	virtual Boolean						IsEqual(TAbstractReference*) = 0;
	virtual	short						Rank();
	virtual	void						SetRank(short rank);		// do nothing - no storage in base class

	//
	// --- Fields -------------------------------------------------------------------------------------
	//

	};

inline short 				TAbstractReference::Rank()						{ return -1; }
inline void 				TAbstractReference::SetRank(short /*rank*/)		{ ; }

DECLARELIST(TAbstractReferenceList, TAbstractReference)
DECLARELOOP(TAbstractReferenceLoop, TAbstractReferenceList, TAbstractReference)
#define FOREACHABSTRACTREFERENCE(listvar) FOREACH(TAbstractReferenceLoop, listvar, TAbstractReference, reference)

#endif

