/*
	File:		GenericSearchSpec.h

	Contains:	xxx put contents here xxx

	Written by:	Andy Nicholas, Greg Anderson, Tom Conrad, Chris Bingham, Georgiann Puckett, John Thompson-Rohrlich

	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.

		 <5>	 9/18/95	ga		

*/


#ifndef GenericSearchSpec_h
#define GenericSearchSpec_h

//
// AbstractSearchSpec.h is needed because
// TAbstractSearchSpec is the base class of TGenericSearchSpec
//
#include "AbstractSearchSpec.h"

class TComparisonOperand;

//========================================================================================
//
//	CLASS TGenericSearchSpec
//
//========================================================================================

class TGenericSearchSpec : public TAbstractSearchSpec
	{
protected:
	DescType							fComparisonOperator;
	TComparisonOperand*					fOperand1;
	TComparisonOperand*					fOperand2;
	
	//
	// --- Methods -------------------------------------------------------------------------------------
	//
public:
	DECLAREOBJECT(TGenericSearchSpec)

	TGenericSearchSpec(DescType comparisonOp, TComparisonOperand* operand1, TComparisonOperand* operand2) :
		fComparisonOperator(comparisonOp),
		fOperand1(operand1),
		fOperand2(operand2) {};
	
	virtual								~TGenericSearchSpec();
	
	// Methods relating to the use of the search specification
	
	virtual DescType					SpecificationOperator();
	virtual TComparisonOperand*			GetRightHandComparisonOperand();
	virtual TComparisonOperand*			GetLeftHandComparisonOperand();
		

	virtual Boolean						Compare(TTransaction* t, TAbstractScriptableObject* itemToTest);
	
	// Methods relating to creating object specifiers for this search specification
	
	virtual TDescriptor					BuildWhoseTest();		
	};


#endif
